/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.MapLoginUserToPegawai;
import com.portofolio.entity.vo.MapLoginUserToPegawaiId;

@Lazy
@Repository
public interface MapLoginUserToPegawaiDao extends CrudRepository<MapLoginUserToPegawai, MapLoginUserToPegawaiId> {

	MapLoginUserToPegawai findOneByIdKdUserAndIdKdPegawaiAndIdKdProfile(Long kdUser, String kdPegawai,
			Integer kdProfile);

	MapLoginUserToPegawai findOneByIdKdPegawaiAndIdKdProfile(String kdPegawai, Integer kdProfile);
	
	MapLoginUserToPegawai findOneByIdKdUserAndIdKdProfile(Long kdUser, Integer kdProfile);

	@Query(QListAll)
	@Cacheable("MapLoginUserToPegawaiDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page);

	@Query(QListAll + " and model.id.kdUser = :kdUser ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("kdUser") Long kdUser,
			Pageable page);

	@Query(QListAll + " and model.id.kdUser = :kdUser")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kdUser") Long kdUser);

	String QListAll = "select new map(kelompokUser.id.kdKelompokUser as kdKelompokUser ,kelompokUser.namaKelompokUser as namaKelompokUser,pegawai.id.kdPegawai as kdPegawai,pegawai.namaLengkap as namaLengkap,loginUser.kdUser as kdUser,loginUser.namaUserEmail as namaUserEmail"
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec " + ", model.version as version )"
			+ " from MapLoginUserToPegawai model left join model.id id left join model.kelompokUser kelompokUser left join model.pegawai pegawai left join model.loginUser loginUser  where id.kdProfile =:kdProfile and model.statusEnabled = true  ";

	@Query("select DISTINCT(model.id.kdUser) from MapLoginUserToPegawai model where model.id.kdPegawai =:kdPegawai and model.statusEnabled = true and model.id.kdProfile =:kdProfile  ")
	String findOneByKdPegawaiDao(@Param("kdPegawai") String kdPegawai, @Param("kdProfile") Integer kdProfile);

	@Query("select DISTINCT(model.id.kdPegawai) from MapLoginUserToPegawai model where model.id.kdUser =:kdUser and model.statusEnabled = true and model.id.kdProfile =:kdProfile  ")
	String findOneByKdUserDao(@Param("kdUser") Integer kdUser, @Param("kdProfile") Integer kdProfile);

	@Modifying
	@Query("update MapLoginUserToPegawai m set m.statusEnabled = false where m.id.kdProfile =:kdProfile and m.id.kdUser=:kdUser  ")
	public void setStatusEnabledFalse(@Param("kdProfile") Integer kdProfile, @Param("kdUser") Long kdUser);

}
